%global uid 133
%global username bacula
%bcond_with nagios

Name:               bacula
Version:            13.0.1
Release:            7%{?dist}
Summary:            Cross platform network backup for Linux, Unix, Mac and Windows
License:            AGPLv3 with exceptions
URL:                http://www.bacula.org
Source0:            http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
Source1:            quickstart_postgresql.txt
Source2:            quickstart_mysql.txt
Source3:            quickstart_sqlite3.txt
Source4:            %{name}.logrotate
Source5:            %{name}-fd.service
Source6:            %{name}-dir.service
Source7:            %{name}-sd.service
Source8:            %{name}-fd.sysconfig
Source9:            %{name}-dir.sysconfig
Source10:           %{name}-sd.sysconfig
Source11:           https://salsa.debian.org/bacula-team/bacula/-/raw/master/debian/additions/bacula-tray-monitor.png#/bacula-tray-monitor.png
Patch3000:          %{name}-openssl.patch
Patch3001:          %{name}-seg-fault.patch
Patch3002:          %{name}-non-free-code.patch
Patch3003:          %{name}-traceback-man.patch
Patch3004:          %{name}-compile-options.patch
Patch3005:          %{name}-install.patch
Patch3006:          %{name}-desktop.patch
Patch3007:          %{name}-docker-plugin.patch
Patch3008:          %{name}-autoconf.patch

BuildRequires:      make autoconf automake gcc gcc-c++
BuildRequires:      perl-interpreter perl-generators sed systemd
BuildRequires:      glibc-devel libacl-devel libstdc++-devel
BuildRequires:      libxml2-devel libcap-devel lzo-devel zlib-devel
BuildRequires:      ncurses-devel openldap-devel openssl-devel
BuildRequires:      qt5-qtbase-devel desktop-file-utils readline-devel
BuildRequires:      mariadb-connector-c-devel sqlite-devel postgresql-devel

%description
Bacula is a set of programs that allow you to manage the backup, recovery, and
verification of computer data across a network of different computers. It is
based on a client/server architecture and is efficient and relatively easy to
use, while offering many advanced storage management features that make it easy
to find and recover lost or damaged files.

%package libs
Summary:            Bacula libraries

%description libs
This package contains basic Bacula libraries.


%package libs-sql
Summary:            Bacula SQL libraries
Provides:           bacula-libs-mysql = %{version}-%{release}
Provides:           bacula-libs-sqlite = %{version}-%{release}
Provides:           bacula-libs-postgresql = %{version}-%{release}

%description libs-sql
This package contains the SQL Bacula libraries, which are used by Director and
Storage daemons. You have to select your preferred catalog library through the
alternatives system.


%package common
Summary:            Common Bacula files
Provides:           group(%username) = %uid
Provides:           user(%username) = %uid
Requires:           bacula-libs = %{version}-%{release}
Requires(pre):      shadow-utils
Requires(postun):   shadow-utils

%description common
This package contains files common to all Bacula daemons.


%package director
Summary:            Bacula Director files
Requires:           bacula-common = %{version}-%{release}
Requires:           bacula-libs = %{version}-%{release}
Requires:           bacula-libs-sql = %{version}-%{release}
Provides:           bacula-director-common = %{version}-%{release}
Provides:           bacula-director-mysql = %{version}-%{release}
Provides:           bacula-director-sqlite = %{version}-%{release}
Provides:           bacula-director-postgresql = %{version}-%{release}
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd

%description director
This package contains the director files.


%package logwatch
Summary:            Bacula Director logwatch scripts
BuildArch:          noarch
Requires:           bacula-director = %{version}-%{release}
Requires:           logwatch

%description logwatch
This package contains logwatch scripts for Bacula Director.


%package storage
Summary:            Bacula storage daemon files
Requires:           bacula-common = %{version}-%{release}
Requires:           bacula-libs = %{version}-%{release}
Requires:           bacula-libs-sql = %{version}-%{release}
Requires:           mt-st mtx
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd
Provides:           bacula-storage-common = %{version}-%{release}
Provides:           bacula-storage-mysql = %{version}-%{release}
Provides:           bacula-storage-sqlite = %{version}-%{release}
Provides:           bacula-storage-postgresql = %{version}-%{release}

%description storage
This package contains the storage daemon, the daemon responsible for writing
the data received from the clients onto tape drives or other mass storage
devices.


%package client
Summary:            Bacula backup client
Requires:           bacula-common = %{version}-%{release}
Requires:           bacula-libs = %{version}-%{release}
Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd

%description client
This package contains the bacula client, the daemon running on the system to be
backed up.


%package console
Summary:            Bacula management console
Requires:           bacula-libs = %{version}-%{release}

%description console
This package contains the command-line management console for the bacula backup
system.


%package console-bat
Summary:            Bacula bat console
Requires:           bacula-libs = %{version}-%{release}
Requires:           dejavu-lgc-sans-fonts

%description console-bat
This package contains the bat version of the bacula management console.


%package traymonitor
Summary:            Bacula system tray monitor
Requires:           bacula-libs = %{version}-%{release}
Requires:           dejavu-lgc-sans-fonts

%description traymonitor
This package contains the Gnome and KDE compatible tray monitor to monitor your
bacula server.


%package devel
Summary:            Bacula development files
Requires:           bacula-libs = %{version}-%{release}
Requires:           bacula-libs-sql = %{version}-%{release}

%description devel
This development package contains static libraries and header files.

%if %{with nagios}
%package -n nagios-plugins-bacula
Summary:            Nagios Plugin - check_bacula
Requires:           bacula-libs = %{version}-%{release}
Requires:           nagios-common

%description -n nagios-plugins-bacula
Provides check_bacula support for Nagios.
%endif


%prep
%autosetup -p1
cp %{SOURCE1} %{SOURCE2} %{SOURCE3} .

pushd autoconf
aclocal -I bacula-macros/ -I gettext-macros/ -I libtool/
popd
autoconf -I autoconf/ -o configure autoconf/configure.in

find updatedb -type f | xargs chmod -x
sed -i -e 's|/bin/dash|/bin/sh|g' scripts/baculabackupreport.in


%build
export CFLAGS="%{optflags} -I%{_includedir}/ncurses"
export CPPFLAGS="%{optflags} -I%{_includedir}/ncurses"
export PATH="$PATH:%{_qt5_bindir}"

%configure \
    --disable-conio \
    --disable-rpath \
    --disable-s3 \
    --docdir=%{_datadir}/bacula \
    --enable-bat \
    --enable-batch-insert \
    --enable-build-dird \
    --enable-build-stored \
    --enable-cdp-plugin \
    --enable-docker-plugin \
    --enable-includes \
    --enable-largefile \
    --enable-ldap-bpam \
    --enable-readline \
    --enable-smartalloc \
    --sysconfdir=%{_sysconfdir}/bacula \
    --with-basename=bacula \
    --with-bsrdir=%{_localstatedir}/spool/bacula \
    --with-dir-password=@@DIR_PASSWORD@@ \
    --with-fd-password=@@FD_PASSWORD@@ \
    --with-hostname=localhost \
    --with-ldap \
    --with-logdir=%{_localstatedir}/log/bacula \
    --with-mon-dir-password=@@MON_DIR_PASSWORD@@ \
    --with-mon-fd-password=@@MON_FD_PASSWORD@@ \
    --with-mon-sd-password=@@MON_SD_PASSWORD@@ \
    --with-mysql \
    --with-openssl \
    --with-pid-dir=%{_localstatedir}/run \
    --with-plugindir=%{_libdir}/%{name} \
    --with-postgresql \
    --with-scriptdir=%{_libexecdir}/bacula \
    --with-sd-password=@@SD_PASSWORD@@ \
    --with-smtp-host=localhost \
    --with-sqlite3 \
    --with-subsys-dir=%{_localstatedir}/lock/subsys \
    --with-working-dir=%{_localstatedir}/spool/bacula \
    --with-x

sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make_build
%if %{with nagios}
%make_build -C examples/nagios/check_bacula
%endif


%install
%make_install
%if %{with nagios}
%make_install -C examples/nagios/check_bacula
%endif

rm -f %{buildroot}%{_libdir}/libbaccats.so

install -p -m 644 -D src/qt-console/images/bat_icon.png %{buildroot}%{_datadir}/pixmaps/bat_icon.png
install -p -m 644 -D scripts/bat.desktop %{buildroot}%{_datadir}/applications/bat.desktop
install -p -m 755 -D src/qt-console/.libs/bat %{buildroot}%{_sbindir}/bat

install -p -m 644 -D manpages/bacula-tray-monitor.1 %{buildroot}%{_mandir}/man1/bacula-tray-monitor.1
install -p -m 644 -D %{SOURCE11} %{buildroot}%{_datadir}/pixmaps/bacula-tray-monitor.png
install -p -m 644 -D scripts/bacula-tray-monitor.desktop %{buildroot}%{_datadir}/applications/bacula-tray-monitor.desktop
install -p -m 755 -D src/qt-console/tray-monitor/.libs/bacula-tray-monitor %{buildroot}%{_sbindir}/bacula-tray-monitor

mkdir -p %{buildroot}%{_localstatedir}/log/bacula
install -p -m 644 -D %{SOURCE4} %{buildroot}%{_sysconfdir}/logrotate.d/bacula

install -p -m 755 -D scripts/logwatch/bacula %{buildroot}%{_sysconfdir}/logwatch/scripts/services/bacula
install -p -m 755 -D scripts/logwatch/applybaculadate %{buildroot}%{_sysconfdir}/logwatch/scripts/shared/applybaculadate
install -p -m 644 -D scripts/logwatch/logfile.bacula.conf %{buildroot}%{_sysconfdir}/logwatch/conf/logfiles/bacula.conf
install -p -m 644 -D scripts/logwatch/services.bacula.conf %{buildroot}%{_sysconfdir}/logwatch/conf/services/bacula.conf

mkdir -p %{buildroot}%{_unitdir}
install -p -m 644 -D %{SOURCE5} %{buildroot}%{_unitdir}/bacula-fd.service
install -p -m 644 -D %{SOURCE6} %{buildroot}%{_unitdir}/bacula-dir.service
install -p -m 644 -D %{SOURCE7} %{buildroot}%{_unitdir}/bacula-sd.service

install -p -m 644 -D %{SOURCE8} %{buildroot}%{_sysconfdir}/sysconfig/bacula-fd
install -p -m 644 -D %{SOURCE9} %{buildroot}%{_sysconfdir}/sysconfig/bacula-dir
install -p -m 644 -D %{SOURCE10} %{buildroot}%{_sysconfdir}/sysconfig/bacula-sd

mkdir -p %{buildroot}%{_localstatedir}/spool/bacula

rm -f %{buildroot}%{_libexecdir}/bacula/{bacula,bacula-ctl-*,startmysql,stopmysql,bconsole,make_catalog_backup}
rm -f %{buildroot}%{_sbindir}/bacula
rm -f %{buildroot}%{_mandir}/man8/bacula.8.gz
rm -f %{buildroot}%{_libdir}/*.la
rm -f %{buildroot}%{_datadir}/bacula/{ChangeLog,INSTALL,LICENSE*,README,ReleaseNotes,VERIFYING,technotes}

chmod 755 %{buildroot}%{_sbindir}/*
chmod 755 %{buildroot}%{_libdir}/%{name}/*
chmod 755 %{buildroot}%{_libexecdir}/bacula/*
chmod 644 %{buildroot}%{_libexecdir}/bacula/btraceback.*


%post libs-sql
/usr/sbin/alternatives --install %{_libdir}/libbaccats.so libbaccats.so %{_libdir}/libbaccats-mysql.so 50
/usr/sbin/alternatives --install %{_libdir}/libbaccats.so libbaccats.so %{_libdir}/libbaccats-sqlite3.so 40
/usr/sbin/alternatives --install %{_libdir}/libbaccats.so libbaccats.so %{_libdir}/libbaccats-postgresql.so 60

if readlink /etc/alternatives/libbaccats.so | grep --silent mysql || \
    readlink /etc/alternatives/bacula-dir | grep --silent mysql || \
    readlink /etc/alternatives/bacula-sd | grep --silent mysql; then
    /usr/sbin/alternatives --set libbaccats.so %{_libdir}/libbaccats-mysql.so
elif readlink /etc/alternatives/libbaccats.so | grep --silent sqlite || \
    readlink /etc/alternatives/bacula-dir | grep --silent sqlite || \
    readlink /etc/alternatives/bacula-sd | grep --silent sqlite; then
    /usr/sbin/alternatives --set libbaccats.so %{_libdir}/libbaccats-sqlite3.so
else
    /usr/sbin/alternatives --set libbaccats.so %{_libdir}/libbaccats-postgresql.so
fi

%preun libs-sql
if [ "$1" = 0 ]; then
    /usr/sbin/alternatives --remove libbaccats.so %{_libdir}/libbaccats-mysql.so
    /usr/sbin/alternatives --remove libbaccats.so %{_libdir}/libbaccats-sqlite3.so
    /usr/sbin/alternatives --remove libbaccats.so %{_libdir}/libbaccats-postgresql.so
fi


%pre common
getent group %username >/dev/null || groupadd -g %uid -r %username &>/dev/null || :
getent passwd %username >/dev/null || useradd -u %uid -r -s /sbin/nologin \
    -d /var/spool/bacula -M -c 'Bacula Backup System' -g %username %username &>/dev/null || :
exit 0


%post client
%systemd_post %{name}-fd.service

%preun client
%systemd_preun %{name}-fd.service

%postun client
%systemd_postun_with_restart %{name}-fd.service


%post director
%systemd_post %{name}-dir.service

%preun director
%systemd_preun %{name}-dir.service

%postun director
%systemd_postun_with_restart %{name}-dir.service


%post storage
%systemd_post %{name}-sd.service

%preun storage
%systemd_preun %{name}-sd.service

%postun storage
%systemd_postun_with_restart %{name}-sd.service


%files libs
%license LICENSE
%doc AUTHORS ChangeLog SUPPORT ReleaseNotes LICENSE-FAQ LICENSE-FOSS
%{_libdir}/libbac-%{version}.so
%{_libdir}/libbaccfg-%{version}.so
%{_libdir}/libbacfind-%{version}.so
%{_libdir}/libbacsd-%{version}.so


%files libs-sql
%{_libdir}/libbaccats-mysql-%{version}.so
%{_libdir}/libbaccats-mysql.so
%{_libdir}/libbaccats-postgresql-%{version}.so
%{_libdir}/libbaccats-postgresql.so
%{_libdir}/libbaccats-sqlite3-%{version}.so
%{_libdir}/libbaccats-sqlite3.so
%{_libdir}/libbacsql-%{version}.so
%exclude %{_libdir}/libbaccats-%{version}.so


%files common
%doc quickstart_*
%config(noreplace) %{_sysconfdir}/logrotate.d/bacula
%dir %{_sysconfdir}/%{name} %attr(755,root,root)
%{_sbindir}/btraceback
%dir %{_libdir}/%{name}
%dir %{_libexecdir}/%{name}
%{_libexecdir}/%{name}/btraceback.dbx
%{_libexecdir}/%{name}/btraceback.gdb
%{_libexecdir}/%{name}/bacula_config
%{_libexecdir}/%{name}/btraceback.mdb
%dir %{_localstatedir}/log/bacula %attr(750, bacula, bacula)
%dir %{_localstatedir}/spool/bacula %attr(750, bacula, bacula)
%{_mandir}/man8/btraceback.8*


%files director
%doc updatedb examples/sample-query.sql
%config(noreplace) %{_sysconfdir}/bacula/bacula-dir.conf %attr(640,root,bacula)
%config(noreplace) %{_sysconfdir}/bacula/query.sql %attr(640,root,bacula)
%config(noreplace) %{_sysconfdir}/sysconfig/bacula-dir
%{_libdir}/%{name}/ldap-dir.so
%{_libexecdir}/%{name}/baculabackupreport
%{_libexecdir}/%{name}/create_bacula_database
%{_libexecdir}/%{name}/delete_catalog_backup
%{_libexecdir}/%{name}/drop_bacula_database
%{_libexecdir}/%{name}/drop_bacula_tables
%{_libexecdir}/%{name}/grant_bacula_privileges
%{_libexecdir}/%{name}/make_bacula_tables
%{_libexecdir}/%{name}/make_catalog_backup.pl
%{_libexecdir}/%{name}/update_bacula_tables
%{_libexecdir}/%{name}/create_mysql_database
%{_libexecdir}/%{name}/drop_mysql_database
%{_libexecdir}/%{name}/drop_mysql_tables
%{_libexecdir}/%{name}/grant_mysql_privileges
%{_libexecdir}/%{name}/make_mysql_tables
%{_libexecdir}/%{name}/update_mysql_tables
%{_libexecdir}/%{name}/create_sqlite3_database
%{_libexecdir}/%{name}/drop_sqlite3_database
%{_libexecdir}/%{name}/drop_sqlite3_tables
%{_libexecdir}/%{name}/grant_sqlite3_privileges
%{_libexecdir}/%{name}/make_sqlite3_tables
%{_libexecdir}/%{name}/update_sqlite3_tables
%{_libexecdir}/%{name}/create_postgresql_database
%{_libexecdir}/%{name}/drop_postgresql_database
%{_libexecdir}/%{name}/drop_postgresql_tables
%{_libexecdir}/%{name}/grant_postgresql_privileges
%{_libexecdir}/%{name}/make_postgresql_tables
%{_libexecdir}/%{name}/update_postgresql_tables
%{_mandir}/man1/bsmtp.1*
%{_mandir}/man8/bacula-dir.8*
%{_mandir}/man8/bregex.8*
%{_mandir}/man8/bwild.8*
%{_mandir}/man8/dbcheck.8*
%{_sbindir}/bacula-dir
%{_sbindir}/bdirjson
%{_sbindir}/bregex
%{_sbindir}/bsmtp
%{_sbindir}/bwild
%{_sbindir}/dbcheck
%{_sbindir}/ldaptest
%{_unitdir}/bacula-dir.service


%files logwatch
%config(noreplace) %{_sysconfdir}/logwatch/conf/logfiles/bacula.conf
%config(noreplace) %{_sysconfdir}/logwatch/conf/services/bacula.conf
%{_sysconfdir}/logwatch/scripts/services/bacula
%{_sysconfdir}/logwatch/scripts/shared/applybaculadate


%files storage
%config(noreplace) %{_sysconfdir}/bacula/bacula-sd.conf %attr(640,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/bacula-sd
%{_libexecdir}/%{name}/disk-changer
%{_libexecdir}/%{name}/isworm
%{_libexecdir}/%{name}/mtx-changer
%{_libexecdir}/%{name}/mtx-changer.conf
%{_libexecdir}/%{name}/tapealert
%{_mandir}/man8/bacula-sd.8*
%{_mandir}/man8/bcopy.8*
%{_mandir}/man8/bextract.8*
%{_mandir}/man8/bls.8*
%{_mandir}/man8/bscan.8*
%{_mandir}/man8/btape.8*
%{_sbindir}/bacula-sd
%{_sbindir}/bcopy
%{_sbindir}/bextract
%{_sbindir}/bls
%{_sbindir}/bscan
%{_sbindir}/bsdjson
%{_sbindir}/btape
%{_unitdir}/bacula-sd.service


%files client
%config(noreplace) %{_sysconfdir}/bacula/bacula-fd.conf %attr(640,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/bacula-fd
%{_libdir}/%{name}/bpipe-fd.so
%{_libdir}/%{name}/cdp-fd.so
%{_libdir}/%{name}/docker-fd.so
%{_sbindir}/bacula-fd
%{_sbindir}/bfdjson
%{_sbindir}/cdp-client
%{_unitdir}/bacula-fd.service
%{_mandir}/man8/bacula-fd.8*


%files console
%config(noreplace) %{_sysconfdir}/bacula/bconsole.conf %attr(640,root,root)
%{_sbindir}/bconsole
%{_sbindir}/bbconsjson
%{_mandir}/man8/bconsole.8*


%files console-bat
%config(noreplace) %{_sysconfdir}/bacula/bat.conf %attr(640,root,root)
%{_sbindir}/bat
%{_datadir}/applications/bat.desktop
%{_datadir}/bacula/*.html
%{_datadir}/bacula/*.png
%{_datadir}/pixmaps/bat_icon.png
%{_mandir}/man1/bat.1*


%files traymonitor
%config(noreplace) %{_sysconfdir}/bacula/bacula-tray-monitor.conf %attr(640,root,root)
%{_sbindir}/bacula-tray-monitor
%{_datadir}/applications/bacula-tray-monitor.desktop
%{_datadir}/pixmaps/bacula-tray-monitor.png
%{_mandir}/man1/bacula-tray-monitor.1*


%files devel
%{_includedir}/bacula
%{_libdir}/libbac.so
%{_libdir}/libbaccfg.so
%{_libdir}/libbacfind.so
%{_libdir}/libbacsd.so
%{_libdir}/libbacsql.so

%if %{with nagios}
%files -n nagios-plugins-bacula
%{_libdir}/nagios/plugins/check_bacula
%endif


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 13.0.1-7
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Aug 18 2023 Wang Guodong <gordonwwang@tencent.com> - 13.0.1-6
- Rebuilt for mariadb-connector-c 3.3.5

* Thu Aug 3 2023 Shuo Wang <abushwang@tencent.com> - 13.0.1-5
- Rebuilt for libpq 15.3

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 13.0.1-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 13.0.1-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Dec 27 2022 rockerzhu <rockerzhu@tencent.com> - 13.0.1-2
- Disable support for nagios

* Mon Dec 12 2022 rockerzhu <rockerzhu@tencent.com> - 13.0.1-1
- Initial build
